From 52509840c7aa5317914ec88bfe44c08bc8255072 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Apr 26 2020 02:46:49 +0000
Subject: [PATCH 467/2232] Replace thiserror dependency with handwritten impls


A dependency wasn't carrying its weight for just two Error impls.

---

diff --git a/BUCK b/BUCK
index 4357dd6..50a9048 100644
--- a/BUCK
+++ b/BUCK
@@ -12,7 +12,6 @@ rust_library(
         "//third-party:proc-macro2",
         "//third-party:quote",
         "//third-party:syn",
-        "//third-party:thiserror",
     ],
 )
 
@@ -30,7 +29,6 @@ rust_binary(
         "//third-party:quote",
         "//third-party:structopt",
         "//third-party:syn",
-        "//third-party:thiserror",
     ],
 )
 
diff --git a/BUILD b/BUILD
index 59ac9fc..2eea8c7 100644
--- a/BUILD
+++ b/BUILD
@@ -15,7 +15,6 @@ rust_library(
         "//third-party:proc-macro2",
         "//third-party:quote",
         "//third-party:syn",
-        "//third-party:thiserror",
     ],
 )
 
@@ -31,7 +30,6 @@ rust_binary(
         "//third-party:quote",
         "//third-party:structopt",
         "//third-party:syn",
-        "//third-party:thiserror",
     ],
 )
 
diff --git a/Cargo.toml b/Cargo.toml
index ad452fe..1d6ede2 100644
--- a/Cargo.toml
+++ b/Cargo.toml
@@ -23,7 +23,6 @@ link-cplusplus = "1.0"
 proc-macro2 = { version = "1.0", features = ["span-locations"] }
 quote = "1.0"
 syn = { version = "1.0", features = ["full"] }
-thiserror = "1.0"
 
 [build-dependencies]
 cc = "1.0.49"
diff --git a/cmd/Cargo.toml b/cmd/Cargo.toml
index e87e1cf..9218478 100644
--- a/cmd/Cargo.toml
+++ b/cmd/Cargo.toml
@@ -21,7 +21,6 @@ proc-macro2 = { version = "1.0", features = ["span-locations"] }
 quote = "1.0"
 structopt = "0.3"
 syn = { version = "1.0", features = ["full"] }
-thiserror = "1.0"
 
 [package.metadata.docs.rs]
 targets = ["x86_64-unknown-linux-gnu"]
diff --git a/gen/error.rs b/gen/error.rs
index ca78acb..2e8ecc4 100644
--- a/gen/error.rs
+++ b/gen/error.rs
@@ -1,15 +1,59 @@
-use crate::gen::Error;
 use crate::syntax;
 use anyhow::anyhow;
 use codespan_reporting::diagnostic::{Diagnostic, Label};
 use codespan_reporting::files::SimpleFiles;
 use codespan_reporting::term::termcolor::{ColorChoice, StandardStream, WriteColor};
 use codespan_reporting::term::{self, Config};
-use std::io::Write;
+use std::error::Error as StdError;
+use std::fmt::{self, Display};
+use std::io::{self, Write};
 use std::ops::Range;
 use std::path::Path;
 use std::process;
 
+pub(super) type Result<T, E = Error> = std::result::Result<T, E>;
+
+#[derive(Debug)]
+pub(super) enum Error {
+    NoBridgeMod,
+    OutOfLineMod,
+    Io(io::Error),
+    Syn(syn::Error),
+}
+
+impl Display for Error {
+    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
+        match self {
+            Error::NoBridgeMod => write!(f, "no #[cxx::bridge] module found"),
+            Error::OutOfLineMod => write!(f, "#[cxx::bridge] module must have inline contents"),
+            Error::Io(err) => err.fmt(f),
+            Error::Syn(err) => err.fmt(f),
+        }
+    }
+}
+
+impl StdError for Error {
+    fn source(&self) -> Option<&(dyn StdError + 'static)> {
+        match self {
+            Error::Io(err) => Some(err),
+            Error::Syn(err) => Some(err),
+            _ => None,
+        }
+    }
+}
+
+impl From<io::Error> for Error {
+    fn from(err: io::Error) -> Self {
+        Error::Io(err)
+    }
+}
+
+impl From<syn::Error> for Error {
+    fn from(err: syn::Error) -> Self {
+        Error::Syn(err)
+    }
+}
+
 pub(super) fn format_err(path: &Path, source: &str, error: Error) -> ! {
     match error {
         Error::Syn(syn_error) => {
diff --git a/gen/mod.rs b/gen/mod.rs
index 4c3a292..928c6ec 100644
--- a/gen/mod.rs
+++ b/gen/mod.rs
@@ -6,29 +6,13 @@ pub(super) mod include;
 pub(super) mod out;
 mod write;
 
-use self::error::format_err;
+use self::error::{format_err, Error, Result};
 use crate::syntax::namespace::Namespace;
 use crate::syntax::{self, check, Types};
 use quote::quote;
 use std::fs;
-use std::io;
 use std::path::Path;
 use syn::{Attribute, File, Item};
-use thiserror::Error;
-
-pub(super) type Result<T, E = Error> = std::result::Result<T, E>;
-
-#[derive(Error, Debug)]
-pub(super) enum Error {
-    #[error("no #[cxx::bridge] module found")]
-    NoBridgeMod,
-    #[error("#[cxx::bridge] module must have inline contents")]
-    OutOfLineMod,
-    #[error(transparent)]
-    Io(#[from] io::Error),
-    #[error(transparent)]
-    Syn(#[from] syn::Error),
-}
 
 struct Input {
     namespace: Namespace,
diff --git a/src/error.rs b/src/error.rs
index 0c19f98..740ab94 100644
--- a/src/error.rs
+++ b/src/error.rs
@@ -1,14 +1,37 @@
+use std::error::Error as StdError;
+use std::fmt::{self, Display};
 use std::io;
-use thiserror::Error;
 
 pub(super) type Result<T, E = Error> = std::result::Result<T, E>;
 
-#[derive(Error, Debug)]
+#[derive(Debug)]
 pub(super) enum Error {
-    #[error("missing OUT_DIR environment variable")]
     MissingOutDir,
-    #[error("failed to locate target dir")]
     TargetDir,
-    #[error(transparent)]
-    Io(#[from] io::Error),
+    Io(io::Error),
+}
+
+impl Display for Error {
+    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
+        match self {
+            Error::MissingOutDir => write!(f, "missing OUT_DIR environment variable"),
+            Error::TargetDir => write!(f, "failed to locate target dir"),
+            Error::Io(err) => err.fmt(f),
+        }
+    }
+}
+
+impl StdError for Error {
+    fn source(&self) -> Option<&(dyn StdError + 'static)> {
+        match self {
+            Error::Io(err) => Some(err),
+            _ => None,
+        }
+    }
+}
+
+impl From<io::Error> for Error {
+    fn from(err: io::Error) -> Self {
+        Error::Io(err)
+    }
 }
diff --git a/third-party/BUCK b/third-party/BUCK
index d8e826f..54a1e85 100644
--- a/third-party/BUCK
+++ b/third-party/BUCK
@@ -170,24 +170,6 @@ rust_library(
 )
 
 rust_library(
-    name = "thiserror",
-    srcs = glob(["vendor/thiserror-1.0.15/src/**"]),
-    visibility = ["PUBLIC"],
-    deps = [":thiserror-impl"],
-)
-
-rust_library(
-    name = "thiserror-impl",
-    srcs = glob(["vendor/thiserror-impl-1.0.15/src/**"]),
-    proc_macro = True,
-    deps = [
-        ":proc-macro2",
-        ":quote",
-        ":syn",
-    ],
-)
-
-rust_library(
     name = "unicode-segmentation",
     srcs = glob(["vendor/unicode-segmentation-1.6.0/src/**"]),
     edition = "2015",
diff --git a/third-party/BUILD b/third-party/BUILD
index 3a2ac5b..c6ce473 100644
--- a/third-party/BUILD
+++ b/third-party/BUILD
@@ -175,24 +175,6 @@ rust_library(
 )
 
 rust_library(
-    name = "thiserror",
-    srcs = glob(["vendor/thiserror-1.0.15/src/**"]),
-    visibility = ["//visibility:public"],
-    deps = [":thiserror-impl"],
-)
-
-rust_library(
-    name = "thiserror-impl",
-    srcs = glob(["vendor/thiserror-impl-1.0.15/src/**"]),
-    crate_type = "proc-macro",
-    deps = [
-        ":proc-macro2",
-        ":quote",
-        ":syn",
-    ],
-)
-
-rust_library(
     name = "unicode-segmentation",
     srcs = glob(["vendor/unicode-segmentation-1.6.0/src/**"]),
     edition = "2015",
